/*
 * Biorhythms.java
 */
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.Date;
import java.text.*;
import java.text.DateFormat;
import java.awt.geom.*;
import java.io.*;


public class Biorhythms extends JFrame 
{
	static JPanel birthPanel = new JPanel();
	static JLabel birthLabel = new JLabel();
	static JSpinner birthMonthSpinner = new JSpinner();
	static JSpinner birthDaySpinner = new JSpinner();
	static JSpinner birthYearSpinner = new JSpinner();

	static JPanel bioPanel = new JPanel();
	static JLabel bioLabel = new JLabel();
	static JSpinner bioMonthSpinner = new JSpinner();
	static JSpinner bioDaySpinner = new JSpinner();
	static JSpinner bioYearSpinner = new JSpinner();

	static JPanel daysPanel = new JPanel();
	static JLabel titleLabel = new JLabel();
	static JLabel daysLabel = new JLabel();

	static BioPanel plotPanel = new BioPanel();
	
	static JButton exitButton = new JButton();
  
	static Font dateFont = new Font("Arial", Font.PLAIN, 18);
  static String[] monthNames = {"January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"};
  static int[] days = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
  static int monthBirth;
  static int dayBirth;
  static int yearBirth;
  static int monthBio;
  static int dayBio;
  static int yearBio;
  static long diffDays;
  static Rectangle2D.Double borderRectangle;

  public static void main(String args[]) 
  {
    // construct frame
    new Biorhythms().show();
    // Read previous birthdate
    // if not there, create
    try
    {
    	BufferedReader inputFile = new BufferedReader(new FileReader("bio.dat"));
    	monthBirth = Integer.valueOf(inputFile.readLine()).intValue();
    	dayBirth = Integer.valueOf(inputFile.readLine()).intValue();
    	yearBirth = Integer.valueOf(inputFile.readLine()).intValue();
    	inputFile.close();
    }
    catch (IOException ex)
    {
      monthBirth = 1;
      dayBirth = 1;
      yearBirth = 1950;
    }
    // Initialize spinners
    birthYearSpinner.setValue(new Integer(yearBirth));
    birthMonthSpinner.setValue(monthNames[monthBirth - 1]);
    birthDaySpinner.setValue(new Integer(dayBirth));
    Date today = new Date();
    monthBio = today.getMonth() + 1;
    dayBio = today.getDate();
    yearBio = today.getYear() + 1900;
    bioYearSpinner.setValue(new Integer(yearBio));
    bioMonthSpinner.setValue(monthNames[monthBio - 1]);
    bioDaySpinner.setValue(new Integer(dayBio));
    updateBioChart();
    adjustDayBio();
    adjustDayBirth();
  }
  public Biorhythms() 
  {
    // frame constructor
    setTitle("Biorhythms");
    setResizable(false);
    getContentPane().setBackground(Color.YELLOW);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
        exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());

    // Position panels and controls
    birthPanel.setLayout(new GridBagLayout());
    birthLabel.setFont(dateFont);
    birthLabel.setText("Birth Date:");
    birthLabel.setForeground(Color.YELLOW);
    GridBagConstraints gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 10, 0, 10);
    birthPanel.add(birthLabel, gridConstraints);
    birthMonthSpinner.setPreferredSize(new Dimension(120, 30));
    birthMonthSpinner.setModel(new SpinnerListModel(monthNames));
    ((JSpinner.DefaultEditor) birthMonthSpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) birthMonthSpinner.getEditor()).getTextField().setFont(dateFont);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(0, 10, 0, 10);
    birthPanel.add(birthMonthSpinner, gridConstraints);
    birthMonthSpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        birthDateChanged(e);
      }
    });
    birthDaySpinner.setPreferredSize(new Dimension(120, 30));
    SpinnerNumberModel birthDayNumberModel = new SpinnerNumberModel(1, 1, 31, 1);
    birthDaySpinner.setModel(birthDayNumberModel);
    ((JSpinner.DefaultEditor) birthDaySpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) birthDaySpinner.getEditor()).getTextField().setFont(dateFont);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(0, 10, 0, 10);
    birthPanel.add(birthDaySpinner, gridConstraints);
    birthDaySpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        birthDateChanged(e);
      }
    });
    
    birthYearSpinner.setPreferredSize(new Dimension(120, 30));
    SpinnerNumberModel birthYearNumberModel = new SpinnerNumberModel(1980, 1700, 2100, 1);
    birthYearSpinner.setModel(birthYearNumberModel);
    //Make the year be formatted without a thousands separator.
    birthYearSpinner.setEditor(new JSpinner.NumberEditor(birthYearSpinner, "#"));
    ((JSpinner.DefaultEditor) birthYearSpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) birthYearSpinner.getEditor()).getTextField().setFont(dateFont);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    gridConstraints.insets = new Insets(0, 10, 10, 10);
    birthPanel.add(birthYearSpinner, gridConstraints);
    birthYearSpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        birthDateChanged(e);
      }
    });
    birthPanel.setBackground(Color.RED);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.gridheight = 3;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(birthPanel, gridConstraints);
    
    bioPanel.setLayout(new GridBagLayout());
    gridConstraints = new GridBagConstraints();
    bioLabel.setFont(dateFont);
    bioLabel.setText("Biorhythm Date:");
    bioLabel.setForeground(Color.YELLOW);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 10, 0, 10);
    bioPanel.add(bioLabel, gridConstraints);
    bioMonthSpinner.setPreferredSize(new Dimension(120, 30));
    bioMonthSpinner.setModel(new SpinnerListModel(monthNames));
    ((JSpinner.DefaultEditor) bioMonthSpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) bioMonthSpinner.getEditor()).getTextField().setFont(dateFont);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(0, 10, 0, 10);
    bioPanel.add(bioMonthSpinner, gridConstraints);
    bioMonthSpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        bioDateChanged(e);
      }
    });
    bioDaySpinner.setPreferredSize(new Dimension(120, 30));
    SpinnerNumberModel bioDayNumberModel = new SpinnerNumberModel(1, 1, 31, 1);
    bioDaySpinner.setModel(bioDayNumberModel);
    ((JSpinner.DefaultEditor) bioDaySpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) bioDaySpinner.getEditor()).getTextField().setFont(dateFont);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(0, 10, 0, 10);
    bioPanel.add(bioDaySpinner, gridConstraints);
    bioDaySpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        bioDateChanged(e);
      }
    });
    bioYearSpinner.setPreferredSize(new Dimension(120, 30));
    SpinnerNumberModel bioYearNumberModel = new SpinnerNumberModel(1980, 1700, 2100, 1);
    bioYearSpinner.setModel(bioYearNumberModel);
    //Make the year be formatted without a thousands separator.
    bioYearSpinner.setEditor(new JSpinner.NumberEditor(bioYearSpinner, "#"));
    ((JSpinner.DefaultEditor) bioYearSpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) bioYearSpinner.getEditor()).getTextField().setFont(dateFont);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    gridConstraints.insets = new Insets(0, 10, 10, 10);
    bioPanel.add(bioYearSpinner, gridConstraints);
    bioYearSpinner.addChangeListener(new ChangeListener()
    {
      public void stateChanged(ChangeEvent e) 
      {
        bioDateChanged(e);
      }
    });
    bioPanel.setBackground(Color.BLUE);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    gridConstraints.gridheight = 3;
    gridConstraints.insets = new Insets(0, 10, 10, 10);
    getContentPane().add(bioPanel, gridConstraints);

    daysPanel.setLayout(new GridBagLayout());
    titleLabel.setFont(dateFont);
    titleLabel.setForeground(Color.YELLOW);
    titleLabel.setText("Days Since Birth:");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    daysPanel.add(titleLabel, gridConstraints);
    daysLabel.setFont(dateFont);
    daysLabel.setBackground(Color.WHITE);
    daysLabel.setOpaque(true);
    daysLabel.setPreferredSize(new Dimension(100, 20));
    daysLabel.setHorizontalAlignment(SwingConstants.CENTER);
    daysLabel.setText("20000");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    daysPanel.add(daysLabel, gridConstraints);
    daysPanel.setBackground(Color.BLACK);
    daysPanel.setPreferredSize(new Dimension(400, 50));
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(daysPanel, gridConstraints);
    
    plotPanel.setBackground(Color.BLACK);
    plotPanel.setPreferredSize(new Dimension (400, 300));
  	borderRectangle = new Rectangle2D.Double(60, 30, 320, 250);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    gridConstraints.gridheight = 5;
    gridConstraints.insets = new Insets(0, 10, 10, 10);
    getContentPane().add(plotPanel, gridConstraints);
    
		exitButton.setText("Exit");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 6;
    gridConstraints.insets = new Insets(10, 10, 10, 10);
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });

    
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
  }
  
  private void birthDateChanged(ChangeEvent e)
  {
  	// Birth date changed
    updateBioChart();
    adjustDayBirth();
  }
  
  private void bioDateChanged(ChangeEvent e)
  {
  	// Bio date changed
    updateBioChart();
    adjustDayBio();
  }

  private static void adjustDayBio()
  {
  	int isLeap;
    // Make sure day of month isn't larger than maximum allowed
    // Check for leap year and February
    if (bioMonthSpinner.getValue().equals("February") && Integer.valueOf(bioYearSpinner.getValue().toString()).intValue() % 4 == 0)
    {
    	isLeap = 1;
    }
    else
    {
    	isLeap = 0;
    }
    int d = Integer.valueOf(bioDaySpinner.getValue().toString()).intValue();
    if (d > days[monthBio - 1] + isLeap)
    {
     	d = days[monthBio - 1] + isLeap;
   	}
    bioDaySpinner.setModel(new SpinnerNumberModel(d, 1, days[monthBio - 1] + isLeap, 1));
    ((JSpinner.DefaultEditor) bioDaySpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) bioDaySpinner.getEditor()).getTextField().setFont(dateFont);
  }
  private static void adjustDayBirth()
  {
  	int isLeap;
    // Make sure day of month isn't larger than maximum allowed
    // Check for leap year and February
    if (birthMonthSpinner.getValue().equals("February") && Integer.valueOf(birthYearSpinner.getValue().toString()).intValue() % 4 == 0)
    {
    	isLeap = 1;
    }
    else
    {
    	isLeap = 0;
    }
    int d = Integer.valueOf(birthDaySpinner.getValue().toString()).intValue();
    if (d > days[monthBirth - 1] + isLeap)
    {
     	d = days[monthBirth - 1] + isLeap;
   	}
    birthDaySpinner.setModel(new SpinnerNumberModel(d, 1, days[monthBirth - 1] + isLeap, 1));
    ((JSpinner.DefaultEditor) birthDaySpinner.getEditor()).getTextField().setHorizontalAlignment(SwingConstants.CENTER);
    ((JSpinner.DefaultEditor) birthDaySpinner.getEditor()).getTextField().setFont(dateFont);
  }
  
  private static void updateBioChart()
  {
  	// compute difference in dates and redraw plot
   	Date bioDay = new Date();
   	Date birthDay = new Date();
   	// find months, days, year
   	for (int i = 0; i < 12; i++)
   	{
   		if (birthMonthSpinner.getValue().toString().equals(monthNames[i]))
   		{
   			monthBirth = i + 1;
   		}
   	}
   	dayBirth = Integer.valueOf(birthDaySpinner.getValue().toString()).intValue();
   	yearBirth = Integer.valueOf(birthYearSpinner.getValue().toString()).intValue();
   	for (int i = 0; i < 12; i++)
   	{
   		if (bioMonthSpinner.getValue().toString().equals(monthNames[i]))
   		{
   			monthBio = i + 1;
   		}
   	}
   	dayBio = Integer.valueOf(bioDaySpinner.getValue().toString()).intValue();
   	yearBio = Integer.valueOf(bioYearSpinner.getValue().toString()).intValue();
   	try
    {
   		birthDay = DateFormat.getDateInstance(DateFormat.SHORT).parse(String.valueOf(monthBirth) 
    		+ "/" + String.valueOf(dayBirth)
    		+ "/" + String.valueOf(yearBirth));
   		bioDay = DateFormat.getDateInstance(DateFormat.SHORT).parse(String.valueOf(monthBio) 
    		+ "/" + String.valueOf(dayBio)
    		+ "/" + String.valueOf(yearBio));
    }
    catch (ParseException ex)
    {
    }
    // compute difference in days
    diffDays = (long) (bioDay.getTime() - birthDay.getTime()) / (60 * 60 * 24 * 1000);
    daysLabel.setText(String.valueOf(diffDays));
    plotPanel.repaint();
  }
  
	private void exitButtonActionPerformed(ActionEvent e)
	{
		exitForm(null);
	}
	private void exitForm(WindowEvent e) 
  {
  	try
  	{
  		PrintWriter outputFile = new PrintWriter(new BufferedWriter(new FileWriter("bio.dat")));
  		outputFile.println(monthBirth);
  		outputFile.println(dayBirth);
  		outputFile.println(yearBirth);
  		outputFile.flush();
  		outputFile.close();
  	}
  	catch (IOException ex)
  	{
  	}
  	finally
  	{
  		System.exit(0);
  	}
  }

}

class BioPanel extends JPanel
{
	public BioPanel()
	{
	}
	public void paintComponent(Graphics g)
	{
		// Draws a  bar chart
  	// borderRectangle - rectangle region to draw plot
  	// n - number of points to plot
  	// d - number of days
  	// find minimums and maximums
  	double yMin = -105.0;
  	double yMax = +105.0;
  	double b = 0.0;
  	int n = 3;
  	double[] y = new double[3];
  	y[0] = 100.0 * Math.sin(2.0 * Math.PI * Biorhythms.diffDays / 23.0);
  	y[1] = 100.0 * Math.sin(2.0 * Math.PI * Biorhythms.diffDays / 28.0);
  	y[2] = 100.0 * Math.sin(2.0 * Math.PI * Biorhythms.diffDays / 33.0);
  	Graphics2D g2D = (Graphics2D) g;
    super.paintComponent(g2D);
    // make border rectangle white
    g2D.setPaint(Color.WHITE);
    g2D.fill(Biorhythms.borderRectangle);
  	// Find bar width in client coordinates
  	// use quarter bar-width as margins between bars
  	double barWidth = (Biorhythms.borderRectangle.width - 1) / 4;
  	double clientBase = yPhysicalToyUser(Biorhythms.borderRectangle, b, yMin, yMax);
  	Rectangle2D.Double myRectangle;
  	for (int i = 0; i < n; i++)
  	{
    	// draw bars
    	if (y[i] > b)
    	{
    		myRectangle = new Rectangle2D.Double(Biorhythms.borderRectangle.x + (1.25 * i + 0.25) * barWidth, yPhysicalToyUser(Biorhythms.borderRectangle, y[i], yMin, yMax), barWidth, clientBase - yPhysicalToyUser(Biorhythms.borderRectangle, y[i], yMin, yMax));
     		g2D.setPaint(Color.GREEN);
   		}
    	else
    	{
    		myRectangle = new Rectangle2D.Double(Biorhythms.borderRectangle.x + (1.25 * i + 0.25) * barWidth, clientBase, barWidth, yPhysicalToyUser(Biorhythms.borderRectangle, y[i], yMin, yMax) - clientBase);
     		g2D.setPaint(Color.RED);
    	}
    	g2D.fill(myRectangle);
    }
  	// line at base
  	g2D.setPaint(Color.BLACK);
  	g2D.draw(new Line2D.Double(Biorhythms.borderRectangle.x, clientBase, Biorhythms.borderRectangle.x + Biorhythms.borderRectangle.width - 1, clientBase));
  	// plot labels
  	Font lFont = new Font("Arial", Font.PLAIN, 12);
  	g2D.setFont(lFont);
  	g2D.setPaint(Color.YELLOW);
  	String s = "High";
  	Rectangle2D sRect = lFont.getStringBounds(s, g2D.getFontRenderContext());
  	g2D.drawString(s, (int) (58 - sRect.getWidth()), (int) (30 + sRect.getHeight()));
  	s = "Critical";
  	sRect = lFont.getStringBounds(s, g2D.getFontRenderContext());
  	g2D.drawString(s, (int) (58 - sRect.getWidth()), (int) (155 + 0.5 * sRect.getHeight()));
  	s = "Low";
  	sRect = lFont.getStringBounds(s, g2D.getFontRenderContext());
  	g2D.drawString(s, (int) (58 - sRect.getWidth()), (int) (280));
  	lFont = new Font("Arial", Font.PLAIN, 14);
  	g2D.setFont(lFont);
  	s = "Physical";
  	sRect = lFont.getStringBounds(s, g2D.getFontRenderContext());
  	g2D.drawString(s, (int) (120 - 0.5 * sRect.getWidth()), (int) (25));
  	s = "Emotional";
  	sRect = lFont.getStringBounds(s, g2D.getFontRenderContext());
  	g2D.drawString(s, (int) (220 - 0.5 * sRect.getWidth()), (int) (25));
  	s = "Intellectual";
  	sRect = lFont.getStringBounds(s, g2D.getFontRenderContext());
  	g2D.drawString(s, (int) (320 - 0.5 * sRect.getWidth()), (int) (25));
  	g2D.dispose();
  }
  private double xPhysicalToxUser(Rectangle2D.Double r, double xPhysical, double xMin, double xMax)
  {
  	return(r.x + (xPhysical - xMin) * (r.width - 1) / (xMax - xMin));
  }
  private double yPhysicalToyUser(Rectangle2D.Double r, double yPhysical, double yMin, double yMax)
  {
  	return(r.y + (yMax - yPhysical) * (r.height - 1) / (yMax - yMin));
  }
	
}