/*
 * GasMileage.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.io.*;
import java.util.*;
import java.awt.geom.*;

public class GasMileage extends JFrame 
{
	
	static JScrollPane mileageScrollPane = new JScrollPane();
	static JTextArea mileageTextArea = new JTextArea();
	static JButton newButton = new JButton();
	static JButton openButton = new JButton();
	static JButton saveButton = new JButton();
	static JButton exitButton = new JButton();
	static JButton addNewButton = new JButton();
	static JButton plotButton = new JButton();
	
	static JPanel addPanel = new JPanel();
	static JLabel dateLabel = new JLabel();
	static JLabel odometerLabel = new JLabel();
	static JLabel gallonsLabel = new JLabel();
	static JTextField dateTextField = new JTextField();
	static JTextField odometerTextField = new JTextField();
	static JTextField gallonsTextField = new JTextField();
	static JButton addEntryButton = new JButton();
	static JButton doneButton = new JButton();
	
	static boolean starting = true;

  static JFileChooser myChooser = new JFileChooser();
  static int numValues;
  static String[] dates = new String[100];
  static double[] odometer = new double[100];
  static double[] gallons = new double[100];
  static double[] recentMileage = new double[100];
  static double[] overallMileage = new double[100];

  public static void main(String args[]) 
  {
  	//construct frame
    new GasMileage().show();
    panelEnabled(false);
    newButton.doClick();
    starting = false;
  }

  public GasMileage() 
  {
  	// code to build the form
    setTitle("Gas Mileage");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
 
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    mileageTextArea.setColumns(48);
    mileageTextArea.setRows(10);
    mileageTextArea.setFont(new Font("Courier New", Font.PLAIN, 12));
    mileageTextArea.setEditable(false);
    mileageScrollPane.setViewportView(mileageTextArea);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.gridwidth = 2;
    gridConstraints.gridheight = 4;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(mileageScrollPane, gridConstraints);
   
    newButton.setText("New");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(newButton, gridConstraints);
    newButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		newButtonActionPerformed(e);
    	}
    });
    
    openButton.setText("Open");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(openButton, gridConstraints);
    openButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		openButtonActionPerformed(e);
    	}
    });
    
    saveButton.setText("Save");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(saveButton, gridConstraints);
    saveButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		saveButtonActionPerformed(e);
    	}
    });
    
    exitButton.setText("Exit");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });
    
    addNewButton.setText("Add New Entry");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(addNewButton, gridConstraints);
    addNewButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		addNewButtonActionPerformed(e);
    	}
    });
    
    plotButton.setText("Plot Gas Mileage");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 4;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(plotButton, gridConstraints);
    plotButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		plotButtonActionPerformed(e);
    	}
    });
    
    addPanel.setLayout(new GridBagLayout());
    addPanel.setBorder(BorderFactory.createTitledBorder("Add New Entry"));
    addPanel.setBackground(Color.YELLOW);
    dateLabel.setText("Date m/d/yy");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 5, 0, 5);
    addPanel.add(dateLabel, gridConstraints);
    dateTextField.setText("");
    dateTextField.setColumns(8);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    addPanel.add(dateTextField, gridConstraints);
    odometerLabel.setText("Odometer Reading");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 5, 0, 5);
    addPanel.add(odometerLabel, gridConstraints);
    odometerTextField.setText("");
    odometerTextField.setColumns(8);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 1;
    addPanel.add(odometerTextField, gridConstraints);
    gallonsLabel.setText("Gallons Pumped");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 0;
    gridConstraints.insets = new Insets(5, 5, 0, 5);
    addPanel.add(gallonsLabel, gridConstraints);
    gallonsTextField.setText("");
    gallonsTextField.setColumns(8);
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    addPanel.add(gallonsTextField, gridConstraints);
		addEntryButton.setText("Add Entry");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(5, 5, 0, 5);
    addPanel.add(addEntryButton, gridConstraints);
    addEntryButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		addEntryButtonActionPerformed(e);
    	}
    });
		doneButton.setText("Done");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    gridConstraints.insets = new Insets(5, 5, 0, 5);
    addPanel.add(doneButton, gridConstraints);
    doneButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		doneButtonActionPerformed(e);
    	}
    });
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 0;
    gridConstraints.gridwidth = 5;
    gridConstraints.gridy = 5;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(addPanel, gridConstraints);
    
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
	}

	private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }
  
	private void newButtonActionPerformed(ActionEvent e)
	{
		if (!starting)
		{
	  	if (JOptionPane.showConfirmDialog(null, "Are you sure you want to start a new file?", "New File", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.NO_OPTION)
    	{
    		return;
    	}
    	else
    	{
    		newFile();
    	}
    }
    else
    {
    	newFile();
    }
	}
 	private void openButtonActionPerformed(ActionEvent e)
	{
		int nMax;
		// Open mileage file
    if (JOptionPane.showConfirmDialog(null, "Are you sure you want to open a new file?", "Open File", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.NO_OPTION)
    {
    	return;
    }

	  StringTokenizer myLine;
	  myChooser.setDialogType(JFileChooser.OPEN_DIALOG);
	  myChooser.setDialogTitle("Open Gas Mileage File");
	  String[] ext = new String[] {"gas"};
	  myChooser.addChoosableFileFilter(new ExampleFileFilter(ext, "Mileage Files"));
	  if (myChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
	  { 
	    try
	    {
	      // Open input file
	      BufferedReader inputFile = new BufferedReader(new FileReader(myChooser.getSelectedFile().toString()));
        newFile();
      	this.setTitle("Gas Mileage-" + myChooser.getSelectedFile().toString());
      	nMax = Integer.valueOf(inputFile.readLine()).intValue();
      	for (numValues = 0; numValues < nMax; numValues++)
      	{
      		myLine = new StringTokenizer(inputFile.readLine(), ",");
      		dates[numValues] = myLine.nextToken();
      		odometer[numValues] = Double.valueOf(myLine.nextToken()).doubleValue();
      		gallons[numValues] = Double.valueOf(myLine.nextToken()).doubleValue();
      		newEntryLine();
      	}
      	numValues = nMax;
				inputFile.close();
	    }
	    catch (IOException ex)
	    {
	       JOptionPane.showConfirmDialog(null, ex.getMessage(), "Error Opening File", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
	    }
	  }

	}
 	private void saveButtonActionPerformed(ActionEvent e)
	{
  	myChooser.setDialogType(JFileChooser.SAVE_DIALOG);
  	myChooser.setDialogTitle("Save Gas Mileage File");
  	String[] ext = new String[] {"gas"};
  	myChooser.addChoosableFileFilter(new ExampleFileFilter(ext, "Mileage Files"));
  	int fp, lp;
  	if (myChooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION)
  	{
  		// see if file already exists
  		if (myChooser.getSelectedFile().exists())
  		{
  			int response;
  			response = JOptionPane.showConfirmDialog(null, myChooser.getSelectedFile().toString() + " exists. Overwrite?", "Confirm Save", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
  			if (response == JOptionPane.NO_OPTION)
  			{
  				return;
  			}
  		} 
  		// make sure file has gas extension
  		// strip off any extension that might be there
  		// then tack on gas
  		String fileName = myChooser.getSelectedFile().toString();
  		int dotlocation = fileName.indexOf(".");
  		if (dotlocation == -1)
  		{
  			// no extension
  			fileName += ".gas";
  		}
  		else
  		{
  			// make sure extension is txt
  			fileName = fileName.substring(0, dotlocation) + ".gas";
  		}
     	this.setTitle("Gas Mileage-" + fileName);
  		try
			{
    		// Open output file and write
      	PrintWriter outputFile = new PrintWriter(new BufferedWriter(new FileWriter(fileName)));
      	outputFile.println(numValues);
      	for (int i = 0; i < numValues; i++)
      	{
      		outputFile.println(dates[i] + "," + odometer[i] + "," + gallons[i]);
      	}
      	outputFile.flush();
    		outputFile.close();
    	}
    	catch (IOException ex)
    	{
    		JOptionPane.showConfirmDialog(null, ex.getMessage(), "Error Writing File", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
    	}
  	}
	}
 	private void exitButtonActionPerformed(ActionEvent e)
	{
    if (JOptionPane.showConfirmDialog(null, "Are you sure you want to exit the program?", "Exit Gas Mileage Program", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.NO_OPTION)
    {
    	return;
    }
    exitForm(null);
	}

	private void addNewButtonActionPerformed(ActionEvent e)
	{
    // Disable buttons - enable Add New frame
    toggleButtons(false);
    panelEnabled(true);
		Date today = new Date();
		dateTextField.setText(DateFormat.getDateInstance(DateFormat.SHORT).format(today));
		dateTextField.requestFocus();
	}
	private void plotButtonActionPerformed(ActionEvent e)
	{
		new GasMileagePlot().show();
	}
	
	private void addEntryButtonActionPerformed(ActionEvent e)
	{
    // Date validation (actual values not checked)
    // checking for just numbers
    // strip out any spaces
    String oldD = dateTextField.getText();
    String newD = "";
    boolean validDate = true;
    for (int i = 0; i < oldD.length(); i ++)
    {
    	char c = oldD.charAt(i);
    	if (c != ' ')
    	{
    		if ((c >= '0' && c <= '9') || c == '/')
    		{
    			newD += oldD.substring(i, i + 1);
    		}
    		else
    		{
    			validDate = false;
    		}
    	}
    }
    if (!validDate)
    {
    	JOptionPane.showConfirmDialog(null, "Error in date - check values and format.", "Date Error", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
    	dateTextField.requestFocus();
			return;
    }
    dateTextField.setText(newD);
    // Make sure miles is greater than previous value
    double miles;
    if (odometerTextField.getText().equals(""))
    {
    	JOptionPane.showConfirmDialog(null, "No odometer reading entered.", "Odometer Reading Error", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
   		odometerTextField.requestFocus();
			return;
    }
    else
    {
    	miles = Double.valueOf(odometerTextField.getText()).doubleValue();
    }
    if (numValues > 0)
    {
    	if (miles <= odometer[numValues - 1])
    	{
    		JOptionPane.showConfirmDialog(null, "Odometer reading less than previous value.", "Odometer Reading Error", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
    		odometerTextField.requestFocus();
				return;
    	}
    }
    // No zero gallons allowed
    double gas;
    if (gallonsTextField.getText().equals(""))
    {
    	JOptionPane.showConfirmDialog(null, "No gallons pumped entered.", "Gallons Pumped Error", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
   		odometerTextField.requestFocus();
			return;
    }
    else
    {
    	gas = Double.valueOf(gallonsTextField.getText()).doubleValue();
    }
    if (gas <= 0)
    {
   		JOptionPane.showConfirmDialog(null, "Gallons pumped must be greater than zero.", "Gallons Pumped Error", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
   		gallonsTextField.requestFocus();
			return;
    }
    dates[numValues] = newD;
    odometer[numValues] = miles;
    gallons[numValues] = gas;
    newEntryLine();
    numValues++;
    dateTextField.setText("m/d/yy");
    odometerTextField.setText("");
    gallonsTextField.setText("");
    dateTextField.requestFocus();
	}
	private void doneButtonActionPerformed(ActionEvent e)
	{
		// Disable add new entry frame
		panelEnabled(false);
    toggleButtons(true);
	}
 


	private static void panelEnabled(boolean status)	
	{
		// toggle enabled status of panel control
		addPanel.setEnabled(status);
		dateTextField.setEnabled(status);
		odometerTextField.setEnabled(status);
		gallonsTextField.setEnabled(status);
		addEntryButton.setEnabled(status);
		doneButton.setEnabled(status);
		
	}
	private void newFile()
	{
		// Clear box and print heading
    mileageTextArea.setText("                             Miles Per Gallon");
    mileageTextArea.append("\n   Date   Odometer  Gallons   Recent  Overall");
    mileageTextArea.append("\n --------------------------------------------");
    numValues = 0;
    this.setTitle("Gas Mileage-New File");
    plotButton.setEnabled(false);
	}
	private void newEntryLine()
	{
		String s;
		String t;
		double m;
		double g;
		char[] myLine = new char[45];
    // Add entry line to text box
    blankLine(myLine);
    midLine(dates[numValues], myLine, 2);
    t = new DecimalFormat("0.0").format(odometer[numValues]);
    midLine(t, myLine, 19 - t.length());
    t = new DecimalFormat("0.0").format(gallons[numValues]);
    midLine(t, myLine, 27 - t.length());
    if (numValues == 0)
    {
      midLine("--.-", myLine, 33);
      midLine("--.-", myLine, 41);
    }
    else
    {
      if (!addPanel.isEnabled())
      {
        plotButton.setEnabled(true);
      }
      // Recent mileage
      m = (odometer[numValues] - odometer[numValues - 1]) / gallons[numValues];
      recentMileage[numValues] = m;
    	t = new DecimalFormat("0.0").format(m);
    	midLine(t, myLine, 37 - t.length());
      // Overall mileage
      g = 0;
      for (int i = 1; i <= numValues; i++)
      {
        g += gallons[i];
      }
      m = (odometer[numValues] - odometer[0]) / g;
      overallMileage[numValues] = m;
    	t = new DecimalFormat("0.0").format(m);
    	midLine(t, myLine, 45 - t.length());
    }
    s = String.copyValueOf(myLine);
    mileageTextArea.append("\n" + s);
	}
	
	private void toggleButtons(boolean v)
	{
    newButton.setEnabled(v);
    openButton.setEnabled(v);
    saveButton.setEnabled(v);
    exitButton.setEnabled(v);
    addNewButton.setEnabled(v);
    plotButton.setEnabled(v);
	}

	
	public void blankLine(char[] charLine)
	{
		for (int i = 0; i < charLine.length; i++)
		{
			charLine[i] = ' ';
		}
	}
	
	public void midLine(String inString, char[] charLine, int pos)
	{
		for (int i = pos; i < pos + inString.length(); i++)
		{
			charLine[i] = inString.charAt(i - pos);
		}
	}

}

class GasMileagePlot extends JFrame 
{
	static JPanel plotPanel = new JPanel();
	static JButton doneButton = new JButton();
	
	public GasMileagePlot() 
  {
  	// code to build the form
    setTitle("Gas Mileage Plot");
    setResizable(false);
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
    // position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    plotPanel.setPreferredSize(new Dimension(400, 300));
    plotPanel.setBackground(Color.WHITE);
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    gridConstraints.gridwidth = 3;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(plotPanel, gridConstraints);
   
    doneButton.setText("Done");
    gridConstraints = new GridBagConstraints();
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    gridConstraints.insets = new Insets(5, 5, 5, 5);
    getContentPane().add(doneButton, gridConstraints);
    doneButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		doneButtonActionPerformed(e);
    	}
    });
  
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());
    
 		// draw plots
		Rectangle2D.Double borderRectangle = new Rectangle2D.Double(50, 30, 330, 250);
		LineChartPanel myLineChart = new LineChartPanel(borderRectangle, GasMileage.numValues, GasMileage.recentMileage, GasMileage.overallMileage);
		myLineChart.setPreferredSize(new Dimension(400, 300));
		myLineChart.setBackground(Color.WHITE);
		plotPanel.removeAll();
		plotPanel.add(myLineChart);
		this.pack();
	}
	
	private void doneButtonActionPerformed(ActionEvent e)
	{
		this.hide();
	}
  private void exitForm(WindowEvent e)
  {
  	this.hide();
  }

}

