import javax.swing.*;
import java.awt.geom.*;
import java.awt.*;
import java.text.*;


public class LineChartPanel extends JPanel 
{
	private Rectangle2D.Double borderRectangle;
	private int n;
	private double[] y1;
	private double[] y2;
	
  public LineChartPanel() 
  {
  	// default constructor for initialization
  }
  
  public LineChartPanel(Rectangle2D.Double border, int nPoints, double[] y1Values, double[] y2Values) 
  {
  	this.borderRectangle = border;
  	this.n = nPoints;
  	this.y1 = y1Values;
  	this.y2 = y2Values;
  }
  public void paintComponent(Graphics g) 
  {
	  double yMin = y1[1]; double yMax = y1[1];
  	// find minimums and maximums
	  for (int i = 2; i < n; i++)
	  {
	  	yMin = Math.min(yMin, y1[i]);
	  	yMax = Math.max(yMax, y1[i]);
	  	yMin = Math.min(yMin, y2[i]);
	  	yMax = Math.max(yMax, y2[i]);
	  }
    Graphics2D g2D = (Graphics2D) g;
    super.paintComponent(g2D);
    Line2D.Double myLine;
    // recent mileage
    g2D.setPaint(Color.BLUE);
    for (int i = 1; i < n - 1; i++)
    {
    	// plot in user coordinates
    	myLine = new Line2D.Double(xPhysicalToxUser(borderRectangle, i, 1, n - 1), yPhysicalToyUser(borderRectangle, y1[i], yMin, yMax), xPhysicalToxUser(borderRectangle, i + 1, 1, n - 1), yPhysicalToyUser(borderRectangle, y1[i + 1], yMin, yMax));
    	g2D.draw(myLine);
    }
  	myLine = new Line2D.Double(50, 15, 100, 15);
   	g2D.draw(myLine);
    // overall mileage
    g2D.setPaint(Color.RED);
    for (int i = 1; i < n - 1; i++)
    {
    	// plot in user coordinates
    	myLine = new Line2D.Double(xPhysicalToxUser(borderRectangle, i, 1, n - 1), yPhysicalToyUser(borderRectangle, y2[i], yMin, yMax), xPhysicalToxUser(borderRectangle, i + 1, 1, n - 1), yPhysicalToyUser(borderRectangle, y2[i + 1], yMin, yMax));
    	g2D.draw(myLine);
    }
  	myLine = new Line2D.Double(220, 15, 270, 15);
   	g2D.draw(myLine);
    // draw border
    g2D.setPaint(Color.BLACK);
    g2D.draw(borderRectangle);
    Font myFont = new Font("Courier New", Font.PLAIN, 12);
    g2D.setFont(myFont);
    g2D.drawString("Recent", 110, 20);
    g2D.drawString("Overall", 280, 20);
    String s = new DecimalFormat("0.0").format(yMax);
    Rectangle2D myRect = myFont.getStringBounds(s, g2D.getFontRenderContext());
    g2D.drawString(s, (int) (48 - myRect.getWidth()), (int) (30 + 0.5 * myRect.getHeight()));
    s = new DecimalFormat("0.0").format(yMin);
    myRect = myFont.getStringBounds(s, g2D.getFontRenderContext());
    g2D.drawString(s, (int) (48 - myRect.getWidth()), (int) (280 + 0.5 * myRect.getHeight()));
    g2D.dispose();
  }
  
  private double xPhysicalToxUser(Rectangle2D.Double r, double xPhysical, double xMin, double xMax)
  {
  	return(r.x + (xPhysical - xMin) * (r.width - 1) / (xMax - xMin));
  }
  private double yPhysicalToyUser(Rectangle2D.Double r, double yPhysical, double yMin, double yMax)
  {
  	return(r.y + (yMax - yPhysical) * (r.height - 1) / (yMax - yMin));
  }
}