/*
 * LoanCalculator.java
 * KIDware (206) 721-2556
 */
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.text.*;
import java.awt.print.*;
import java.awt.font.*;
import java.awt.geom.*;

public class LoanCalculator extends JFrame 
{
	
	static JLabel loanLabel = new JLabel();
	static JLabel interestLabel = new JLabel();
	static JLabel monthsLabel = new JLabel();
	static JLabel paymentLabel = new JLabel();
	static JTextField loanTextField = new JTextField();
	static JTextField interestTextField = new JTextField();
	static JTextField monthsTextField = new JTextField();
	static JTextField paymentTextField = new JTextField();
	static JButton computeButton = new JButton();
	static JButton printButton = new JButton();
	static JButton exitButton = new JButton();
	
	static double loan;
	static double interest;
	static int months;
	static double payment;
	static final int monthsPerPage = 36; // 3 years on each page
	static int numberOfPages;

  public static void main(String args[]) 
  {
  	//construct frame
    new LoanCalculator().show();
  }

  public LoanCalculator() 
  {
  	// code to build the form
    setTitle("Loan Calculator");
    addWindowListener(new WindowAdapter() 
    {
      public void windowClosing(WindowEvent e) 
      {
    		exitForm(e);
      }
    });
    getContentPane().setLayout(new GridBagLayout());
    
		// position controls (establish event methods)
    GridBagConstraints gridConstraints = new GridBagConstraints();
    loanLabel.setText("Loan Amount");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 0;
    getContentPane().add(loanLabel, gridConstraints);
    interestLabel.setText("Yearly Interest");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 1;
    getContentPane().add(interestLabel, gridConstraints);
    monthsLabel.setText("Number of Months");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 2;
    getContentPane().add(monthsLabel, gridConstraints);
    paymentLabel.setText("Monthly Payment");
    gridConstraints.gridx = 0;
    gridConstraints.gridy = 3;
    getContentPane().add(paymentLabel, gridConstraints);

    loanTextField.setText("");
    loanTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 0;
    getContentPane().add(loanTextField, gridConstraints);
    loanTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		loanTextFieldActionPerformed(e);
    	}
    });

    interestTextField.setText("");
    interestTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 1;
    getContentPane().add(interestTextField, gridConstraints);
    interestTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		interestTextFieldActionPerformed(e);
    	}
    });

    monthsTextField.setText("");
    monthsTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 2;
    getContentPane().add(monthsTextField, gridConstraints);
    monthsTextField.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		monthsTextFieldActionPerformed(e);
    	}
    });

    paymentTextField.setText("");
    paymentTextField.setFocusable(false);
    paymentTextField.setColumns(10);
    gridConstraints.gridx = 2;
    gridConstraints.gridy = 3;
    getContentPane().add(paymentTextField, gridConstraints);
    
    computeButton.setText("Compute Payment");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 4;
    getContentPane().add(computeButton, gridConstraints);
    computeButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		computeButtonActionPerformed(e);
    	}
    });
    printButton.setText("Print Payment Schedule");
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 5;
    getContentPane().add(printButton, gridConstraints);
    printButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		printButtonActionPerformed(e);
    	}
    });
    exitButton.setText("Exit");
    exitButton.setFocusable(false);
    gridConstraints.gridx = 1;
    gridConstraints.gridy = 6;
    getContentPane().add(exitButton, gridConstraints);
    exitButton.addActionListener(new ActionListener()
    {
    	public void actionPerformed(ActionEvent e)
    	{
    		exitButtonActionPerformed(e);
    	}
    });
    pack();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((int) (0.5 * (screenSize.width - getWidth())), (int) (0.5 * (screenSize.height - getHeight())), getWidth(), getHeight());

	}
	
	private void loanTextFieldActionPerformed(ActionEvent e)
	{
		loanTextField.transferFocus();
	}
	
	private void interestTextFieldActionPerformed(ActionEvent e)
	{
		interestTextField.transferFocus();
	}
	
	private void monthsTextFieldActionPerformed(ActionEvent e)
	{
		monthsTextField.transferFocus();
	}
	
	private void computeButtonActionPerformed(ActionEvent e)
	{
		// make sure each is a valid number
		if (!validateDecimalNumber(monthsTextField) || !validateDecimalNumber(interestTextField) || !validateDecimalNumber(loanTextField))
		{
			// if one or more fields not valid number, then exit method
			return;
		}
    // read values from text fields
    loan = Double.valueOf(loanTextField.getText()).doubleValue();
    interest = Double.valueOf(interestTextField.getText()).doubleValue();
    months = Integer.valueOf(monthsTextField.getText()).intValue();
    // compute payment and put in text field;
    payment = loanPayment(loan, interest, months);
    if (payment < 0)
    {
    	monthsTextField.setText("");
    	monthsTextField.requestFocus();
    }
    else
    {
      paymentTextField.setText(new DecimalFormat("0.00").format(payment));
    }
	}

		
	private void printButtonActionPerformed(ActionEvent e)
	{
  	// print repayment schedule
    // This assumes payment has been computed
    numberOfPages = (int) ((months - 1) / monthsPerPage) + 1;
	 	PrinterJob myPrinterJob = PrinterJob.getPrinterJob();
    myPrinterJob.setPrintable(new MyDocument());
    try
    {
      myPrinterJob.print();
    }
    catch (PrinterException ex)
    {
      JOptionPane.showConfirmDialog(null, ex.getMessage(), "Print Error", JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE);
    }

	}
	
	private void exitButtonActionPerformed(ActionEvent e)
	{
  	System.exit(0);
	}
	
  private void exitForm(WindowEvent e)
  {
  	System.exit(0);
  }
	
	private double loanPayment(double loan, double interest, double months)
	{
	  // Compute loan payment method
	  double multiplier;
	  double payment;
    if (months == 0)
    {
			JOptionPane.showConfirmDialog(null, "Need non-zero value for Number of Months", "Error", JOptionPane.DEFAULT_OPTION, JOptionPane.INFORMATION_MESSAGE);
      return(-1); // set negative value for error flag
    }
    if (interest != 0)
    {
    	multiplier = Math.pow((1 + interest / 1200), months);
			payment = loan * interest * multiplier / (1200 * (multiplier - 1));
    }
    else
    {
      payment = loan / months;
    }
    // round payment to two decimals
		payment = Double.valueOf(new DecimalFormat("0.00").format(payment)).doubleValue();
		return (payment);

  }

	public boolean validateDecimalNumber(JTextField tf)
	{
		// checks to see if text field contains
		// valid decimal number with only digits and a single decimal point
		String s = tf.getText().trim();
		boolean hasDecimal = false;
		boolean valid = true;
		if (s.length() == 0)
		{
			valid = false;
		}
		else
		{
			for (int i = 0; i < s.length(); i++)
			{
				char c = s.charAt(i);
				if (c >= '0' && c <= '9')
				{
					continue;
				}
				else if (c == '.' && !hasDecimal)
				{
					hasDecimal = true;
				}
				else
				{
					// invalid character found
					valid = false;
				}
			}
		}
		if (valid)
		{
			tf.setText(s);
		}
		else
		{
			tf.setText("");
			tf.requestFocus();
		}
		return (valid);
	}
}
class MyDocument implements Printable
{
  public int print(Graphics g, PageFormat pf, int pageIndex)
  {
  	if (pageIndex > LoanCalculator.numberOfPages - 1)
  	{
  		return NO_SUCH_PAGE;
  	}
  	// print repayment knowing loan values
  	// makes no assumptions about how many times print method is called per page
    Graphics2D g2D = (Graphics2D) g;
    Font printFont = new Font("Courier New", Font.PLAIN, 12);
    Rectangle2D fontRect = printFont.getStringBounds("A", g2D.getFontRenderContext());
    double currentY = pf.getImageableY() + fontRect.getHeight();
    g2D.setFont(printFont);
    // Print header
    g2D.drawString("Loan Repayment Schedule - Page " + String.valueOf(pageIndex + 1), (int) pf.getImageableX(), (int) currentY);
    currentY += 2 * fontRect.getHeight();
    g2D.drawString("Loan Amount: $" + new DecimalFormat("0.00").format(LoanCalculator.loan), (int) pf.getImageableX(), (int) currentY);
    currentY += fontRect.getHeight();
    g2D.drawString("Interest Rate: " + new DecimalFormat("0.00").format(LoanCalculator.interest) + "%", (int) pf.getImageableX(), (int) currentY);
    currentY += fontRect.getHeight();
    g2D.drawString("Number of Months: " + String.valueOf(LoanCalculator.months), (int) pf.getImageableX(), (int) currentY);
    currentY += fontRect.getHeight();
    g2D.drawString("Payment Amount: $" + new DecimalFormat("0.00").format(LoanCalculator.payment), (int) pf.getImageableX(), (int) currentY);
    currentY += 2 * fontRect.getHeight();
    g2D.setFont(new Font("Courier New", Font.BOLD, 12));
    g2D.drawString("Month     Payment     Principal     Interest     Balance", (int) pf.getImageableX(), (int) currentY);
    g2D.setFont(new Font("Courier New", Font.PLAIN, 12));
    currentY += fontRect.getHeight();
    double b;
    double pa;
    double p;
    double i;
    int mstart;
    int mend;
    // compute balance remaining at start of current page
    b = LoanCalculator.loan;
    if (pageIndex !=0)
    {
    	for (int m = 1; m <= (pageIndex * LoanCalculator.monthsPerPage); m++)
    	{
      	// Find interest
      	i = LoanCalculator.interest * b / 1200;
      	// Round to two decimals
				i = Double.valueOf(new DecimalFormat("0.00").format(i)).doubleValue();
				// Calculate balance
        b -= LoanCalculator.payment - i;
    	}
    }
    // find month range on current page
    mstart = (pageIndex * LoanCalculator.monthsPerPage) + 1;
    mend = mstart + LoanCalculator.monthsPerPage - 1;
    if (mend > LoanCalculator.months)
    {
    	mend = LoanCalculator.months;
    }
    // compute current page payment schedule
		for (int m = mstart; m <= mend; m++)
		{
      // Find interest
      i = LoanCalculator.interest * b / 1200;
      // Round to two decimals
			i = Double.valueOf(new DecimalFormat("0.00").format(i)).doubleValue();
			// Determine payment amount - Compute principal and balance
      if (m != LoanCalculator.months)
      {
      	pa = LoanCalculator.payment;
        p = pa - i;
        b -= p;
      }
      else
      {
        // Adjust last payment to payoff balance
        pa = b + i;
        p = b;
        b = 0;
      }
      // Print payment line
    	currentY += fontRect.getHeight();
      g2D.drawString(paymentLine(m, pa, p, i, b), (int) pf.getImageableX(), (int) currentY);
    }
    return PAGE_EXISTS;
  }
  
  private String paymentLine(int m, double pa, double p, double i, double b)
  {
  	// build up line with payoff information
  	//  using info from Chapter 6
  	char[] pl = new char[60];
  	String s;
  	// blank out line with spaces
  	for (int j = 0; j < 60; j++)
  	{
  		pl[j] = ' ';
  	}
    // Months
    s = String.valueOf(m);
    midLine(s, pl, 4 - s.length());
    // Payment amount
		s = new DecimalFormat("0.00").format(pa);
    midLine(s, pl, 17 - s.length());
    // Principal
		s = new DecimalFormat("0.00").format(p);
    midLine(s, pl, 31 - s.length());
    // Interest
		s = new DecimalFormat("0.00").format(i);
    midLine(s, pl, 44 - s.length());
    // Balance
		s = new DecimalFormat("0.00").format(b);
    midLine(s, pl, 56 - s.length());
    // convert character array to string
    s = String.copyValueOf(pl);
    return (s);
  }
  
  private void midLine(String inString, char[] charLine, int pos)
  {
  	for (int i = pos; i < pos + inString.length(); i++)
  	{
  		charLine[i] = inString.charAt(i - pos);
  	}
  }
 }
